SDL_timer.h File Reference
`#include "SDL_stdinc.h"`
`#include "SDL_error.h"`
`#include "begin_code.h"`
`#include "close_code.h"`
Include dependency graph for SDL_timer.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Macros

#define | SDL_TICKS_PASSED(A, B)

## Typedefs

typedef Uint32(* | SDL_TimerCallback) (Uint32 interval, void *param)
typedef int | SDL_TimerID

## Functions

Uint32 | SDL_GetTicks (void)
Uint64 | SDL_GetTicks64 (void)
Uint64 | SDL_GetPerformanceCounter (void)
Uint64 | SDL_GetPerformanceFrequency (void)
void | SDL_Delay (Uint32 ms)
SDL_TimerID | SDL_AddTimer (Uint32 interval, SDL_TimerCallback callback, void *param)
SDL_bool | SDL_RemoveTimer (SDL_TimerID id)

## Macro Definition Documentation

## SDL_TICKS_PASSED

#define SDL_TICKS_PASSED | ( |  | A,
|  |  | B )

Value:
((Sint32)((B) - (A)) <= 0)
Sint32
int32_t Sint32
Definition SDL_stdinc.h:224

Compare 32-bit SDL ticks values, and return true if A has passed B.

This should be used with results from SDL_GetTicks(), as this macro attempts to deal with the 32-bit counter wrapping back to zero every ~49 days, but should not be used with SDL_GetTicks64(), which does not have that problem.

For example, with SDL_GetTicks(), if you want to wait 100 ms, you could do this:

const Uint32 timeout = SDL_GetTicks() + 100;
while (!SDL_TICKS_PASSED(SDL_GetTicks(), timeout)) {
// ... do work until timeout has elapsed
}
Uint32
uint32_t Uint32
Definition SDL_stdinc.h:231
SDL_GetTicks
Uint32 SDL_GetTicks(void)
SDL_TICKS_PASSED
#define SDL_TICKS_PASSED(A, B)
Definition SDL_timer.h:106

Note that this does not handle tick differences greater than 2^31 so take care when using the above kind of code with large timeout delays (tens of days).

Definition at line 106 of file SDL_timer.h.

## Typedef Documentation

## SDL_TimerCallback

typedef Uint32(* SDL_TimerCallback) (Uint32 interval, void *param)

Function prototype for the timer callback function.

The callback function is passed the current timer interval and returns the next timer interval. If the returned value is the same as the one passed in, the periodic alarm continues, otherwise a new alarm is scheduled. If the callback returns 0, the periodic alarm is cancelled.

Definition at line 157 of file SDL_timer.h.

## SDL_TimerID

typedef int SDL_TimerID

Definition of the timer ID type.

Definition at line 162 of file SDL_timer.h.

## Function Documentation

## SDL_AddTimer()

SDL_TimerID SDL_AddTimer | ( | Uint32 | interval,
|  | SDL_TimerCallback | callback,
|  | void * | param )

extern

Call a callback function at a future time.

If you use this function, you must pass SDL_INIT_TIMER to SDL_Init().

The callback function is passed the current timer interval and the user supplied parameter from the SDL_AddTimer() call and should return the next timer interval. If the value returned from the callback is 0, the timer is canceled.

The callback is run on a separate thread.

Timers take into account the amount of time it took to execute the callback. For example, if the callback took 250 ms to execute and returned 1000 (ms), the timer would only wait another 750 ms before its next iteration.

Timing may be inexact due to OS scheduling. Be sure to note the current time with SDL_GetTicks() or SDL_GetPerformanceCounter() in case your callback needs to adjust for variances.

Parameters

  interval | the timer delay, in milliseconds, passed to callback.
  callback | the SDL_TimerCallback function to call when the specified interval elapses.
  param | a pointer that is passed to callback.

Returns
  a timer ID or 0 if an error occurs; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_RemoveTimer

## SDL_Delay()

void SDL_Delay | ( | Uint32 | ms | ) |

extern

Wait a specified number of milliseconds before returning.

This function waits a specified number of milliseconds before returning. It waits at least the specified time, but possibly longer due to OS scheduling.

Parameters

  ms | the number of milliseconds to delay.

Since
  This function is available since SDL 2.0.0.

## SDL_GetPerformanceCounter()

Uint64 SDL_GetPerformanceCounter | ( | void |  | ) |

extern

Get the current value of the high resolution counter.

This function is typically used for profiling.

The counter values are only meaningful relative to each other. Differences between values can be converted to times by using SDL_GetPerformanceFrequency().

Returns
  the current counter value.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GetPerformanceFrequency

## SDL_GetPerformanceFrequency()

Uint64 SDL_GetPerformanceFrequency | ( | void |  | ) |

extern

Get the count per second of the high resolution counter.

Returns
  a platform-specific count per second.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GetPerformanceCounter

## SDL_GetTicks()

Uint32 SDL_GetTicks | ( | void |  | ) |

extern

# CategoryTimer

Header for the SDL time management routines. Get the number of milliseconds since SDL library initialization.

This value wraps if the program runs for more than ~49 days.

This function is not recommended as of SDL 2.0.18; use SDL_GetTicks64() instead, where the value doesn't wrap every ~49 days. There are places in SDL where we provide a 32-bit timestamp that can not change without breaking binary compatibility, though, so this function isn't officially deprecated.

Returns
  an unsigned 32-bit value representing the number of milliseconds since the SDL library initialized.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_TICKS_PASSED

## SDL_GetTicks64()

Uint64 SDL_GetTicks64 | ( | void |  | ) |

extern

Get the number of milliseconds since SDL library initialization.

Note that you should not use the SDL_TICKS_PASSED macro with values returned by this function, as that macro does clever math to compensate for the 32-bit overflow every ~49 days that SDL_GetTicks() suffers from. 64-bit values from this function can be safely compared directly.

For example, if you want to wait 100 ms, you could do this:

const Uint64 timeout = SDL_GetTicks64() + 100;
while (SDL_GetTicks64() < timeout) {
// ... do work until timeout has elapsed
}
Uint64
uint64_t Uint64
Definition SDL_stdinc.h:245
SDL_GetTicks64
Uint64 SDL_GetTicks64(void)

Returns
  an unsigned 64-bit value representing the number of milliseconds since the SDL library initialized.

Since
  This function is available since SDL 2.0.18.

## SDL_RemoveTimer()

SDL_bool SDL_RemoveTimer | ( | SDL_TimerID | id | ) |

extern

Remove a timer created with SDL_AddTimer().

Parameters

  id | the ID of the timer to remove.

Returns
  SDL_TRUE if the timer is removed or SDL_FALSE if the timer wasn't found.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_AddTimer